﻿// InDesignのinddファイルでページ外にテキストフレームがあったらエイリアスを作成
(function(){
    // inddファイルがあるフォルダを指定する
    var folderObj = Folder.selectDialog("文字を検索するインデザイン(indd)ファイルがあるフォルダを選択してください");
    if (!folderObj){ return; }  // キャンセルされた場合は何も処理しない
    // エイリアスを入れるフォルダを指定する
    var saveFolder = Folder.selectDialog("結果（エイリアス）を保存するフォルダを選択してください");
    if (!saveFolder){ return; }  // キャンセルされた場合は何も処理しない
    makeAliasList(folderObj);
    alert("チェックが終了しました");
    // エイリアスを作成する関数
    function makeAliasList(folderObj){
        // inddファイル一覧を取得する
        var fileList = folderObj.getFiles("*.indd");
        // ファイルの数だけ開いて文字列を検索する
        for(var i=0; i<fileList.length; i++){
            app.open(fileList[i]);
            var flag = checkTextFrame(app.activeDocument);
            if (flag == true){
                // ファイル名が重複しないようにスラッシュをアンダーバーにしたファイル名を使う
                var filename = fileList[i].fsName.replace(new RegExp("/", "g"), "_");
                // エイリアスとなるファイルオブジェクトを作成する
                var aliasFileObj = new File(saveFolder+"/"+filename);
                // エイリアスを作成する
                var flag = aliasFileObj.createAlias(fileList[i]);
                if (flag == false){
                    $.writeln("失敗："+filename);
                    // もし、アラートダイアログを表示した方がいい場合は以下の行の//を消してください。
                    // alert("失敗："+filename);
                }
            }
            app.activeDocument.close(SaveOptions.no);
        }
        // フォルダを含めた一覧を取得する
        fileList = folderObj.getFiles();
        for(var i=0; i<fileList.length; i++){
            // フォルダかどうか調べる
            if(fileList[i].getFiles){
                makeAliasList(fileList[i]);  // フォルダの場合は再帰呼び出し
            }
        }
        // ページ外にテキストフレームがあるかどうか調べる
        function checkTextFrame(docObj){
            var tfAllObj = docObj.textFrames;
            var total = 0;
            for(var i=0; i<docObj.pages.length; i++){
                total = total + docObj.pages[i].textFrames.length;
            }
            if (total != tfAllObj.length){
                // ページ内にあるテキストフレームと全体のテキストフレームの数が不一致ならページ外にあり
                return true;
            }
            return false;
        }
    }
})();
